Attribute VB_Name = "Globals"
Option Explicit

Public Const cMsgBoxErrorText = "Error!"

Public Const cINIAppName = "GravityBox\LineGraphExample"
Public Const cINISection = "RecentFiles"

Private Const cRegistrationKey = "Registration"

Public Const gWebAddress = "http://www.gravitybox.com"
Public Const gEmailText = "feedback@gravitybox.com"
                       
Public gAboutIcon As StdPicture

Public Const cdlOFNExplorer = &H80000
Public Const cdlOFNHideReadOnly = &H4
Public Const cdlOFNOverwritePrompt = &H2
Public Const cdlOFNPathMustExist = &H800

Public Function AppPath() As String

Dim sText As String

  sText = App.Path
  If Right(sText, 1) <> "\" Then sText = sText & "\"
  AppPath = sText

End Function
Public Sub SetErr(ErrorNumber As Long, ErrText As String, ByVal ProcName As String)

On Error Resume Next

Dim sDisplayMsg As String
  
  sDisplayMsg = "Error: " & ErrorNumber & vbCrLf & _
                ErrText & vbCrLf & _
                "ProcName: " & ProcName
  Call MsgBox(sDisplayMsg, vbExclamation, cMsgBoxErrorText & " - " & App.Title)
  
End Sub
Public Function GetFileName(ByVal sExt As String) As String

On Error GoTo ErrHandler

Dim Dialog1 As Object
  
  Set Dialog1 = CreateObject("MSComDlg.CommonDialog")
  Dialog1.CancelError = True
  Dialog1.MaxFileSize = 255
  Dialog1.DialogTitle = "Save As"
  Dialog1.DefaultExt = sExt
  Dialog1.Filter = "Graph Files (*." & sExt & ")|*." & sExt & ""
  Dialog1.Flags = cdlOFNExplorer Or cdlOFNHideReadOnly Or cdlOFNOverwritePrompt Or cdlOFNPathMustExist
  Dialog1.FileName = ""
  Dialog1.ShowSave
  GetFileName = Dialog1.FileName
  
EndSub:
  Set Dialog1 = Nothing
  Exit Function
  
ErrHandler:
  If Err <> 32755 Then
    Call SetErr(Err, Err.Description, "GetFileName")
  End If
  GetFileName = ""
  GoTo EndSub
  Resume

End Function
