VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NameCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Col As New Collection
Public Sub Add(ByVal Name As String, Optional ByVal Before As Variant, Optional ByVal After As Variant)

Dim Element As New NameElement
Dim idx As Integer
  
  'If both specified then error
  'only one can be specified
  If Not (IsMissing(Before) Or IsMissing(After)) Then
    Err.Raise vbObjectError + 12, , "Can not specify both parameters 'Before' and 'After'"
    Exit Sub
  End If
  
  'Set the Properties
  Element.Name = Name
  
  If IsMissing(Before) And IsMissing(After) Then
    GoSub RegularAdd
  ElseIf IsMissing(After) Then
    m_Col.Add Element, Name, Before
  ElseIf IsMissing(Before) Then
    m_Col.Add Element, Name, , After
  End If
  Exit Sub
  
RegularAdd:
  idx = ArrayIndex(Name)
  If (idx = 0) And (Count = 0) Then
    m_Col.Add Element, Name
  ElseIf (idx = 0) And (Count > 0) Then
    m_Col.Add Element, Name, 1
  ElseIf Count = idx Then
    m_Col.Add Element, Name, , Count
  Else
    m_Col.Add Element, Name, , idx
  End If
  Set Element = Nothing
  Return

End Sub
Public Sub Clear()

Dim i As Integer

  For i = 1 To Count
    Remove 1
  Next i

End Sub
Public Property Get Count() As Integer
  Count = m_Col.Count
End Property
Public Property Get Exists(ByVal Value As String) As Boolean

Dim i As Integer
Dim idx As Integer

  Value = LCase(Value)
  idx = ArrayIndex(Value)
  If idx = 0 Then
    Exists = False
  ElseIf StrComp(Item(idx).Name, Value, vbTextCompare) = 0 Then
    Exists = True
  Else
    Exists = False
  End If
  
  'For i = 1 To Count
  '  If LCase(Item(i).Name) = Value Then
  '    Exists = True
  '    Exit Property
  '  End If
  'Next i
  'Exists = False

End Property
Private Function ArrayIndex(sValue As String) As Integer

'This does a binary search
'and returns the index

Dim i As Integer
Dim iFirst As Integer
Dim iLast As Integer
Dim iCur As Integer

  If Count = 0 Then
    ArrayIndex = 0
    Exit Function
  End If
  
  iFirst = 1
  iLast = Count
  iCur = 1
  
  While iFirst < iLast
    'Get the middle element
    iCur = Fix((iFirst + iLast) / CSng(2))
    If StrComp(sValue, Item(iCur).Name, vbTextCompare) < 0 Then
      iCur = iCur - 1
      iLast = iCur
    ElseIf StrComp(sValue, Item(iCur).Name, vbTextCompare) > 0 Then
      iCur = iCur + 1
      iFirst = iCur
    Else
      ArrayIndex = iCur
      Exit Function
    End If
  Wend
    
  If iCur = 0 Then
    ArrayIndex = 0
  ElseIf LCase(sValue) < LCase(Item(iCur).Name) Then
    ArrayIndex = iCur - 1
  Else
    ArrayIndex = iCur
  End If
    
End Function
Public Function FileSize() As Long
  
Dim i As Integer
Dim lSize As Long

  For i = 1 To Count
    lSize = lSize + Item(i).FileSize
  Next i
  FileSize = lSize
  
End Function
Public Property Get Item(ByVal idx As Variant) As NameElement
Attribute Item.VB_UserMemId = 0
  Set Item = m_Col(idx)
End Property

Public Sub Remove(ByVal idx As Variant)
  m_Col.Remove idx
End Sub
Private Sub Class_Terminate()
  Set m_Col = Nothing
End Sub
